unit Holfloat;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TForm2 = class(TForm)
    BtnClose2: TButton;
    btnStopGo: TButton;
    btnCapture: TButton;
    btnSize: TButton;
    PaintBox2: TPaintBox;
    procedure BtnClose2Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnStopGoClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FormDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure btnCaptureClick(Sender: TObject);
  private
    { Private declarations }
    SaveNumber : integer;
    CurrPath : string;
    procedure WMGetMinMaxInfo(var Message : TWMGetMinMaxInfo); message
      WM_GETMINMAXINFO;
    procedure WMNCHitTest(var M: TWMNCHitTest); message wm_NCHitTest;
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses HolMain;

{$R *.DFM}

procedure TForm2.WMGetMinMaxInfo(var Message : TWMGetMinMaxInfo);
begin
  with Message.MinMaxInfo^ do
  begin
    ptMinTrackSize.X := 214;
    ptMinTrackSize.Y := 114;
    {ptMaxTrackSize.X := 640;
    ptMaxTrackSize.Y := 480;}
  end;
  Message.Result := 0;
  inherited;
end;

procedure TForm2.WMNCHitTest(var M: TWMNCHitTest);
begin
  inherited;
  if M.Result = htclient then M.Result := htCaption;
end;

procedure TForm2.BtnClose2Click(Sender: TObject);
begin
  Ymin := Form1HeightTall;
  Ymax := 0;
  Form1.Height := Form1HeightTall;
  OneForm := True;
  Form2.Close;
end;

procedure TForm2.FormResize(Sender: TObject);
begin
  btnStopGo.Width := ClientWidth - btnStopGo.Left;
  PaintBox2.Canvas.Brush.Color := BackColor;
  PaintBox2.Canvas.FillRect(Rect(0,0,ClientWidth,ClientHeight));
  btnSize.Caption := IntToStr(Form2.Width) + ' X '
    + IntToStr(Form2.ClientHeight - btnStopGo.Height);
end;

procedure TForm2.btnStopGoClick(Sender: TObject);
begin
  if btnStopGo.Caption = '&Stop'
    then Form1.SpotStop
    else Form1.SpotGo;
end;

procedure TForm2.FormActivate(Sender: TObject);
begin
  btnStopGo.caption := Form1.btnStop.Caption;
end;

procedure TForm2.FormDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := True;
end;

procedure TForm2.FormDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  Form1.FormDragDrop(Sender,Source,X,Y);
end;

procedure TForm2.FormCreate(Sender: TObject);
var
  LookFor : string;
  PrevFile, FileCount : String;
  MySearchRec : TSearchRec;
begin
  ControlStyle := ControlStyle + [csOpaque];
  CurrPath := ExtractFilePath(Application.ExeName);
  LookFor := CurrPath + 'SPOTS*.BMP';
  PrevFile := '';
  SaveNumber := 0;
  If FindFirst(LookFor,faAnyfile,MySearchRec) = 0 then
    repeat PrevFile := MySearchRec.name
      until FindNext(MySearchRec) <> 0;
  If PrevFile <> '' then
    begin
      FileCount := Copy(PrevFile,6,1);
      try
        SaveNumber := StrToInt(FileCount) + 1;
      except
        abort;
      end;
      if SaveNumber = 9 then SaveNumber := 0;
    end;
end;

procedure TForm2.btnCaptureClick(Sender: TObject);
var
  SrcRect, DestRect : TRect;
  Bitmap1 : TBitmap;
  NewFile : String;
begin  {Copy Form's Canvas to internal bitmap.}
  SrcRect := PaintBox2.ClientRect;
  with SrcRect do begin
    Top := Top + btnCapture.Height;
    end;
  try
  Bitmap1 := TBitmap.create;
  Bitmap1.width := PaintBox2.clientwidth;
  Bitmap1.height := PaintBox2.clientheight
    - Form2.btnCapture.Height;
  try
    Bitmap1.Canvas.CopyRect(ClientRect,PaintBox2.Canvas,SrcRect);
    try
      {Assemble Filename to save bitmap to.}
      Newfile := CurrPath + 'SPOTS' + IntToStr(SaveNumber) + '.BMP';
      if SaveNumber = 9 then SaveNumber := 0 else inc(SaveNumber);
      Bitmap1.SaveToFile(NewFile);
      Form1.Panel2.Caption := ' Saved as: ' + NewFile;
    except
      ShowMessage('Unable to Save Picture');
    end;
  finally
    Bitmap1.free;
  end;
  except
    ShowMessage('Not enough memory to copy picture');
  end;
end;

end.
